LDCONFIG(8)

NAME
ldconfig - configure the shared library cache

SYNOPSIS
ldconfig [-mrsv] [-f hints_file] [directory ...]

DESCRIPTION
ldconfig is used to prepare a set of “hints” for use by the run-time linker ld.so(1) to facilitate quick lookup of shared libraries available in multiple directories. It scans a set of built-in system directories and any directories specified on the command line (in the given order) looking for shared libraries and stores the results in the file /var/run/ld.so.hints to forestall the overhead that would otherwise result from the directory search operations ld.so(1) would have to perform to load the required shared libraries.

The shared libraries so found will be automatically available for loading if needed by the program being prepared for execution. This obviates the need for storing search paths within the executable.

The LD_LIBRARY_PATH environment variable can be used to override the use of directories (or the order thereof) from the cache or to specify additional directories where shared libraries might be found. LD_LIBRARY_PATH is a ‘’ separated list of directory paths which are searched by ld.so(1) when it needs to load a shared library. It can be viewed as the run-time equivalent of the -L switch of ld(1).

Ldconfig is typically run as part of the boot sequence.

The following options recognized by ldconfig:

-f hints_file
    Read and/or update the specified hints file, instead of /var/run/ld.so.hints. This option is provided primarily for testing.

-m  Instead of replacing the contents of the hints file with those found in the directories specified, “merge” in new entries. Directories recorded in the hints file by previous runs of ldconfig are also rescanned for new shared libraries.

-r  List the current contents of the hints file on the standard output. The hints file is not modified.

-s  Do not scan the built-in system directory (“/usr/lib”) for shared libraries.

-v  Switch on verbose mode.

Security
Special care must be taken when loading shared libraries into the address space of set-user-Id programs. Whenever such a program is run, ld.so will only load shared libraries from the hints file. In particular, the LD_LIBRARY_PATH is not used to search for libraries. Thus, the role of ldconfig is dual. In addition to building a set of hints for quick lookup, it also serves to specify the trusted collection of directories from which shared objects can be safely loaded. It is presumed that the set of directories specified to ldconfig are under control of the system's administrator.

FILES
/var/run/ld.so.hints

SEE ALSO
ld(1), link(5)

HISTORY
A ldconfig utility first appeared in SunOS 4.0, it appeared in its current form in FreeBSD 1.1.